

#include "flight.h"


/* *************************************************************
************************************************************* */
int flight::query_whatwasi(int type) {

   return (flight::query_whatami() == type) ? 1 : wwdigo::query_whatwasi(type);
}


/* *************************************************************
   place object based on local and parent xforms

1) calc new location
2) vpn = new direction = new loc - old loc
3) if new direction about same as old direction, use old vup, vright
4) else calc new vup/vright based upon plane created by new/old direction vectors
5) 2 possible vups/right -> vup, smallest rotation...


want to rotate around "z" until y[1] is positive, and x[1] = 0, as long as
z != { 0, +-1, 0 }
1) figure out positive or neg rotation around z, and the rotation
2) 1) A = old matrix, B = rotate mx
3) new matrix C = A*B


************************************************************* */
void flight::whereami(dbl_llist_manager *hiearchy_manager, quark *parent, vector4f *mx) {

   linktype *ptr;
   vector3f new_vz;
   vector4f r[4];

   init_mx(state.xmx);
   calc_initmx(state.xmx, r);

   new_vz[0] = r[0][3] - old_local_pos[0];
   new_vz[1] = r[1][3] - old_local_pos[1];
   new_vz[2] = r[2][3] - old_local_pos[2];
   calc_orientation(new_vz);

   old_local_pos[0] = r[0][3];
   old_local_pos[1] = r[1][3];
   old_local_pos[2] = r[2][3];

   copyarray3(state.xmx[0], old_vx);
   copyarray3(state.xmx[1], old_vy);
   copyarray3(state.xmx[2], old_vz);
   copyarray3(state.xmx[3], old_local_pos);

   transpose(state.xmx);
   matmatmulto(mx, state.xmx);

   copymx4x4o(state.node, state.xmx);

   for (ptr=(linktype *)edge.head; ptr; ptr=(linktype *)ptr->next)
      if (ptr->link != parent)                     
         ptr->link->whereami(hiearchy_manager, this, state.node);

   state.center[0] = state.xmx[0][3];
   state.center[1] = state.xmx[1][3];
   state.center[2] = state.xmx[2][3];
   state.center[3] = 1;
}

